%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% relabel all nodes, such that 1 to NG are generator nodes, NG+1 to NG+NL are consumer
% nodes, NG+NL+1 to N are junction nodes
testt1=1;
testt2=N;
NG=length(GBusOld);
testt3=NG+1;
for i=1:N;
    if PG(i)~=0
        NewBus(testt1,1)=i;
        testt1=testt1+1;
    end
    if PG(i)==0 && PL(i)~=0
        NewBus(testt3,1)=i;
        testt3=testt3+1;
    end
    if PG(i)==0 && PL(i)==0
        NewBus(testt2,1)=i;
        testt2=testt2-1;
    end
    NewBus(i,2)=i;
end

Nline=length(FBus);

for i=1:Nline
    p=FBus(i);
    q=TBus(i);
    newp=find(NewBus(:,1)==p);
    newq=find(NewBus(:,1)==q);
    NewFBus(i,1)=NewBus(newp,2);
    NewTBus(i,1)=NewBus(newq,2);
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%







%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% calculate the admittance matrix  Y

% Admittance of Transmission Line
for i=1:linesize
    p=NewFBus(i);
    q=NewTBus(i); 
    Y(p,q)=1/Zline(i);
    Y(q,p)=Y(p,q);
end

% Transformer Tap Setting
% for i=1:linesize
%     if Mag(i)==0
%         continue;
%     else
%         p=NewFBus(i);
%         q=NewTBus(i); 
%         Y(p,q)=Y(p,q)/Mag(i)^2;
%         Y(q,p)=Y(p,q);
%     end
% end


% Half line B
Y_sum=sum(Y);
for i=1:linesize
    p=NewFBus(i);
    q=NewTBus(i);
    if Bline(i)==0
        continue;
    else
        clear j;
        Y_sum(p)=Y_sum(p)+0.5*j*Bline(i);
        Y_sum(q)=Y_sum(q)+0.5*j*Bline(i);
    end
end



Y_sum=diag(Y_sum);
Y=Y_sum-Y;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%






%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Kron reduction
red=length(find(PG+PL~=0));
Yrr=Y(1:red,1:red);
Yre=Y(1:red,red+1:N);
Yee=Y(red+1:N,red+1:N);
Yer=Y(red+1:N,1:red);
Yred=Yrr-Yre*inv(Yee)*Yer;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
