
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% initical conditions
global D N NG P P0 M R Hwn maxdPpercent K flag pos dM dMdown varyR vR dY ddY dy lPratio dPpercent sigma lPtrans0 lPtrans maxPLpercent TripPL PCNG PG PG0 beta;
N=NewN; % number of nodes
NG=10;% number of generators
M=MM; % adjacency matrix
PG(1:NG,1)=TM;
PCNG(1:NG,1)=-TCNG; 
P(1:NG,1)=PG-PCNG;
P(NG+1:N,1)=TCNC; %consumer in isolation
P=P-mean(P); % neglect power loss by average P, such that sum(P)=0 meaning power output form generator=power obtianed by consumer.
D(1:NG,1)=2*ones(NG,1); % generator damping
D(NG+1:N,1)=3*ones(N-NG,1);% consumer damping
Hwn=H2M;% normalized inertia of generator
flag=ones(N,1);
P00=P;







%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% control parameters
dM=ones(N); % initial condition for time-varying coupling weight
dMdown=0; % indicate how much the coupling weight decrease dMdown=0 indicating canstant coupling

if plotflag==0
    maxdPpercent=5000*ones(NG,1);  % unlimit
    varyR=0;
end

if plotflag==1
    maxdPpercent=150*ones(NG,1);  % lose one generator
    varyR=0;
end

if plotflag==2
    maxdPpercent=80*ones(NG,1);  % lose all
    varyR=0;
end


if plotflag==3
    maxdPpercent=20*ones(NG,1);  % smart control 1
    varyR=1; 
end

if plotflag==4
    maxdPpercent=20*ones(NG,1);  % smart control 2 for eta=0.2
    varyR=2;
end

if plotflag==5
    maxdPpercent=17*ones(NG,1)+[0:NG-1]';  % smart control 2 for eta=0.17-0.25
    varyR=2;
end

backupmax=maxdPpercent.*PG;
beta=backupmax/max(backupmax); 

maxPLpercent=10000000; % maximum percent of outage in power-line
%end of control parameters
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%




R=zeros(N,1);  % turbine governor parameter
vR=ones(N,1);  % initial parameter for varying R
for i=1:NG
    R(i)=1;
end
% initical conditions ends
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%




%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% steady state, calculating the initial state of the dynamic state
y0=zeros(N+NG,1); % initials
timestep=0.01; % time step
timestart=0;  % start time
timeend=20; % end time
[T,Y]=rk4(@swing,y0,timestep,timestart,timeend); T=T';Y=Y'; % 4-order RK method to solve swing Eq.
tsize=length(T);

y0=Y(tsize,:); %repeat swing to get more accurate initials for dynamic process
[T,Y]=rk4_repeat(@swing,y0,timestep,timestart,timeend); T=T';Y=Y'; % 4-order RK method to solve swing Eq.

steTheta(:,1:N)=Y(:,1:N);
steOmega(:,1:NG)=Y(:,N+1:N+NG);
steOmega(:,NG+1:N)=dY(NG+1:N,:)';

% steady state ends
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% dynamic state

% manually set, such that we firstly lose the maximum P
y0=Y(tsize,:); %initial condition for dynamic state
timestart=timeend-7;  % start time of dynamic==end tiem of steady state
timeend=timestart+30; % end time of dynamic
timestep=10e-4;
PG0=PG; % remember initial P


%cascading start
[TT,YY]=turbinegovernor(@swing,y0,timestep,timestart,timeend);TT=TT';YY=YY';
%cascading end
dynTheta(:,1:N)=YY(:,1:N);
dynOmega(:,1:NG)=YY(:,N+1:N+NG);
dynOmega(:,NG+1:N)=ddY(NG+1:N,:)';
dY=dY'; ddY=ddY';


