clear all;

readdata; %%% read initial data from excel files. The data is from power flow 
          %%% calculation results which can be referred to I. Hiskens, IEEE PES Task Force on Benchmark Systems for
          %%% Stability Controls, Tech. Rep. (2013).

          
Kron; %%% do the Kron reduction to eliminate all junciton nodes and reserve all generators and loads

para_norm;

%%% Assign a number for plotflag, such that the code runs to output results
%%% for different scenarios
plotflag=5;
%plotflag=0:unlimit backup power,no generator lose, corresponding to Figs. 2 (a) and (b); 
%plotflag=1:lose 1 generator, corresponding to Figs. 2 (c) and (d); 
%plotflag=2:lose all generators, corresponding to Figs. 2 (e) and (f); 
%plotflag=3:smart control 1, corresponding to Fig. 3;
%plotflag=4:smart control 2 for eta =0.2, corresponding to Fig. 4 (a)
%plotflag=5:smart control 2 for eta =0.17-0.25, corresponding to Fig. 4 (b)
           
dynamic;

if plotflag==0
    plotit_unlim;
end

if plotflag==1
    plotit_lose1;
end

if plotflag==2
    plotit_loseall;
end

if plotflag==3
    plotit_smartcontrol1;
end

if plotflag==4
    plotit_smartcontrol2;
end

if plotflag==5
    plotit_smartcontrol2;
end

