function [x,y]=turbinegovernor(swing,y0,h,a,b)
global D N NG P P0 M R Hwn maxdPpercent dPpercent K flag pos dM dMdown varyR vR dY ddY dy lPratio sigma lPtrans0 lPtrans maxPLpercent TripPL PCNG PG PG0 beta;

Ti=0;
Ti1=0;
Trip=0;

nn=floor((b-a)/h); % total number of iteration
x(1)=a; % initial time, start time
y(:,1)=y0; % initial condition for y
ddY=dY;

for ii=1:nn
    
    if floor(x(ii)/h)==20/h;
        pos=find(PG==max(PG)); % find the maximum P        
        flag(pos)=0;
        PG=PG.*flag(1:NG);
        R=R.*flag;
        for i=1:N
            dM(pos,i)=1-dMdown;
            dM(i,pos)=1-dMdown;
        end
    end
    
    % cascading failure process
    P(1:NG)=PG-PCNG;
    dP=PG-PG0(1:NG);
    dPpercent(:,ii)=dP./PG0(1:NG)*100;
    if varyR==1 % varying R
        for i=1:NG
            if y(N+i,ii)<0
                vR(i)=(maxdPpercent(i)-dPpercent(i,ii))/maxdPpercent(i);
            else
                Pmin(i)=0.5*PG0(i);
                vR(i)=(PG(i)-Pmin(i))/(PG0(i)-Pmin(i));
            end
        end
    end
    
    if varyR==2
        vR=beta;
        PG=PG + (-R(1:NG)/100 .* vR(1:NG) .* mean(y(N+1:N+NG,ii)));
        mean(y(N+1:N+NG,ii));
    else
        PG=PG + (-R(1:NG) .* vR(1:NG) .* y(N+1:N+NG,ii));
    end
    
    
    sigma(:,ii)=dPpercent(:,ii)./maxdPpercent;
    
    
    dPpercent(pos,ii)=0;

    
    for i=1:NG
        if dPpercent(i,ii)>maxdPpercent(i)+1e-3 && flag(i)~=0 % check outage of generator
            flag(i)=0;
            Ti=Ti+1;
            Trip(1,Ti)=x(ii);
            Trip(2,Ti)=i;
            %             for j=1:N
            %                 dM(i,j)=1-dMdown;
            %                 dM(j,i)=dM(i,j);
            %             end
            dM=dM*(1-dMdown);
        end
    end
    PG=PG.*flag(1:NG);
    R=R.*flag;
    
    %
    %     ly=y(1:N,ii);   % power-line outage
    %     lry = repmat(ly(1:N),1,N);
    %     lPtrans = abs(M.*dM.* sin(lry-lry'));
    %     lPratio{ii}=lPtrans./lPtrans0;
    
    
    
    %     for i=1:N-1
    %         for j=i+1:N
    %             if lPtrans(i,j)>lPtrans0(i,j)*(1+maxPLpercent/100)
    %                 Ti1=Ti1+1;
    %                 M(i,j)=0;
    %                 M(j,i)=0;
    %                 TripPL(1,Ti1)=i;
    %                 TripPL(2,Ti1)=j;
    %             end
    %         end
    %     end
    %    cascading failure process end
    
    
    x(ii+1)=x(ii)+h;
    k1=swing(x(ii),y(:,ii));
    k2=swing(x(ii)+h/2,y(:,ii)+h*k1/2);
    k3=swing(x(ii)+h/2,y(:,ii)+h*k2/2);
    k4=swing(x(ii)+h,y(:,ii)+h*k3);
    y(:,ii+1)=y(:,ii)+h*(k1+2*k2+2*k3+k4)/6;
    ddY(:,ii+1)=(k1+2*k2+2*k3+k4)/6;
    
end
assignin('base','Trip',Trip);
end
